---
- name: "[cinder storage class][{{ storage_class }}][RWO] create test PVC"
  run_once: true
  kubernetes.core.k8s:
    state: present
    definition:
      apiVersion: v1
      kind: PersistentVolumeClaim
      metadata:
        name: "claim-test-{{ storage_class }}-rwo"
        namespace: default
      spec:
        accessModes:
          - ReadWriteOnce
        storageClassName: "{{ storage_class }}"
        resources:
          requests:
            storage: 1Mi

- name: |
    [cinder storage class][{{ storage_class }}][RWO]
    wait for test PVC to be ready
  kubernetes.core.k8s_info:
    api_version: v1
    kind: PersistentVolumeClaim
    name: "claim-test-{{ storage_class }}-rwo"
    namespace: default
  register: pvc
  changed_when:
    &pvc_test pvc.resources is defined and
    pvc.resources | length > 0 and
    pvc.resources[0].status is defined and
    pvc.resources[0].status.phase == "Bound"
  until: *pvc_test
  retries: 900
  delay: 1

- name: "[cinder storage class][{{ storage_class }}][RWO] delete test PVC"
  run_once: true
  kubernetes.core.k8s:
    state: absent
    definition:
      apiVersion: v1
      kind: PersistentVolumeClaim
      metadata:
        name: "claim-test-{{ storage_class }}-rwo"
        namespace: default

- name: "[cinder storage class][{{ storage_class }}][RWO] create test STS"
  run_once: true
  kubernetes.core.k8s:
    state: present
    template:
      path: rwo_statefulset_test.yml.j2
  loop:
    - "{{ storage_class }}"

- name: |
    [cinder storage class][{{ storage_class }}][RWO]
    wait for test STS to be ready
  kubernetes.core.k8s_info:
    api_version: apps/v1
    kind: StatefulSet
    name: "test-rwo-{{ storage_class }}"
    namespace: default
  register: sts
  changed_when:
    &sts_test sts.resources is defined and
    sts.resources | length > 0 and
    sts.resources[0].status.readyReplicas is defined and
    sts.resources[0].status.readyReplicas == sts.resources[0].status.replicas
  until: *sts_test
  retries: 900
  delay: 1

- name: "[cinder storage class][{{ storage_class }}][RWO] delete test STS"
  kubernetes.core.k8s:
    state: absent
    wait: true
    definition:
      apiVersion: apps/v1
      kind: StatefulSet
      metadata:
        name: "test-rwo-csi-{{ storage_class }}"
        namespace: default

- name: "[cinder storage class][{{ storage_class }}][RWO] delete PVC"
  kubernetes.core.k8s:
    state: absent
    definition:
      apiVersion: v1
      kind: PersistentVolumeClaim
      metadata:
        name: "somewhere-test-rwo-csi-{{ storage_class }}-{{ item }}"
        namespace: default
  loop: "{{ range(compute_nodes_number|int + 1) | list }}"
